



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JS与Jquery的事件委托——解决了绑定相同事件的问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JS与Jquery的事件委托——解决了绑定相同事件的问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 16:07:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>概念：</strong></p>
<p>　　什么是事件委托：通俗的讲，事件就是onclick，onmouseover，onmouseout，等就是事件，委托呢，就是让别人来做，这个事件本来是加在某些元素上的，然而你却加到别人身上来做，完成这个事件。<br>　　举个列子：有三个同事预计会在周一收到快递。为签收快递，有两种办法：一是三个人在公司门口等快递；二是委托给前台MM代为签收。现实当中，我们大都采用委托的方案（公司也不会容忍那么多员工站在门口就为了等快递）。前台MM收到快递后，她会判断收件人是谁，然后按照收件人的要求签收，甚至代为付款。这种方案还有一个优势，那就是即使公司里来了新员工（不管多少），前台MM也会在收到寄给新员工的快递后核实并代为签收。</p>
<p><strong>原理：</strong></p>
<p>　　利用冒泡的原理，把事件加到父级上，触发执行效果。</p>
<p><strong>作用：</strong></p>
<p>1.性能要好<br>2.针对新创建的元素，直接可以拥有事件</p>
<p><strong>事件源 :&nbsp;</strong></p>
<p>　　跟this作用一样(他不用看指向问题，谁操作的就是谁),event对象下的</p>
<p><strong>使用情景：</strong></p>
<p>　　•为DOM中的很多元素绑定相同事件；<br>　　•为DOM中尚不存在的元素绑定事件；</p>
<p><strong>JS的事件委托</strong></p>
<p><strong>Jquery的事件委托</strong></p>
<div>
<pre class="prettyprint linenums">$(function(){
    $('#ul1,#ul2').delegate('li','click',function(){
        if(!$(this).attr('s')) {
        $(this).css('background','red');
        $(this).attr('s',true);
        }else {
            $(this).css('background','#fff');
            $(this).removeAttr('s');
        }
    })
});</pre>
</div>
<p>最新on()方法取替了delegate()方法</p>
<div>
<pre class="prettyprint linenums">$(function(){
        $('#ul1,#ul2').on('click','li',function(){
                if(!$(this).attr('s')) {
                $(this).css('background','red');
                $(this).attr('s',true);
                }else {
                        $(this).css('background','#fff');
                        $(this).removeAttr('s');
                }
        })
});</pre>
</div>
<p>注：原文出处 &nbsp;http://www.cnblogs.com/thinksasa/p/3941739.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m963ejj9.html">Caliburn&period;Micro学习笔记&lpar;一&rpar;----引导类和命名匹配规则</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j435g9.html">MySql取得日期（前一天、某一天）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv6gz18.html">刨根问底拦不住&mdash;&mdash;I&sol;O模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q27zvl8.html">linux web服务器静态资源的处理 unison&plus;inotify双向同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yndo3q.html">angularJS图表-angular-flot</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z12exd9.html">&period;net线程同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xv7v08.html">简单的介绍下WPF中的MVVM框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdgmdl8.html">php的mq客户端获取队列方法改造</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmypr9.html">LayoutInflater 类的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ylpwr8.html">Java经典编程题50道之十</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zor3j9.html">SLAM&plus;语音机器人DIY系列：（一）Linux基础&mdash;&mdash;2&period;安装Linux发行版ubuntu系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zynppd9.html">Mysql 存储过程中使用多游标</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwnlxx9.html">pta l3-1（凑零钱）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7eo4n19.html">jsack</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppeejy9.html">scriptlet</a>
		</li>
						<li><a href="https://www.batexi.com/a/qveo60x9.html">Latex中文utf-8编码的三种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o404o5q.html">linux之 LVM扩容</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kzx53q.html">Http协议中关于Content-Length的解读【出现坑爹的视频中断】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pprg279.html">layer 遮罩层等待</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj7xgzq.html">linux-sftp-指定端口号登录远程主机</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mnw31oq.html">bzoj1975</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1y3128.html">iOS开发：Swift多线程GCD的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1jd6x9.html">Drupal 7&period;31版本爆严重SQL注入漏洞</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oy6jj9.html">asp&period;net实现GZip压缩和GZip解压</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okgxg19.html">事务报错 &lbrack;Exception&rsqb; 当前 TransactionScope 已完成</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdek0m09.html">&lpar;转&rpar;TCP协议那些事</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdekjp09.html">Android WindowManager 监听返回键及home键</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z13vwv9.html">两段简单的JS代码防止SQL注入</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k12m3j9.html">&lbrack;Web API&rsqb; 如何让 Web API 统一回传格式以及例外处理&lbrack;转&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmvnl19.html">Redrain个人维护并使用的DuiLib和UiLib库源码下载地址</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
